"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HtmlEditorFloatEditToolbar = void 0;
var react_1 = __importStar(require("react"));
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var react_2 = require("@tiptap/react");
var util_1 = require("primeobjects-ui-web-application/build/cjs/util");
var html_float_highlight_toolbar_content_1 = __importDefault(require("./html-float-highlight-toolbar-content"));
var html_float_edit_toolbar_content_1 = __importDefault(require("./html-float-edit-toolbar-content"));
var html_editor_edit_tooltip_1 = __importDefault(require("./html-editor-edit-tooltip"));
var lodash_1 = require("lodash");
var HtmlEditorFloatEditToolbarContent = undefined;
var HtmlEditorFloatHighlightToolbarContent = undefined;
var HtmlEditorFloatEditToolbar = function (props) {
    if (!HtmlEditorFloatEditToolbarContent) {
        console.log("Get global components in /html-float-edit-toolbar.tsx");
        HtmlEditorFloatEditToolbarContent = (0, util_1.getGlobalComponent)("HtmlEditorFloatEditToolbarContent", html_float_edit_toolbar_content_1.default);
        HtmlEditorFloatHighlightToolbarContent = (0, util_1.getGlobalComponent)("HtmlEditorFloatHighlightToolbarContent", html_float_highlight_toolbar_content_1.default);
    }
    var editor = props.editor, hideH1 = props.hideH1, hideH2 = props.hideH2, hideH3 = props.hideH3, hideH4 = props.hideH4, supportSourceCode = props.supportSourceCode, customButtons = props.customButtons, onHighlight = props.onHighlight, colors = props.colors, supportHighlight = props.supportHighlight, supportTooltips = props.supportTooltips;
    var _a = (0, react_1.useState)(undefined), editTooltipId = _a[0], setEditTooltipId = _a[1];
    var _b = (0, react_1.useState)({}), tooltips = _b[0], setTooltips = _b[1];
    (0, react_1.useEffect)(function () {
        setTooltips(props.tooltips ? props.tooltips : {});
    }, [props.tooltips]);
    var propsHtmlEditorFloatEditToolbarContent = {
        editor: editor,
        hideH1: hideH1,
        hideH2: hideH2,
        hideH3: hideH3,
        hideH4: hideH4,
        supportSourceCode: supportSourceCode
    };
    var propsHtmlEditorFloatHighlightToolbarContent = {
        editor: editor,
        customButtons: customButtons,
        onHighlight: onHighlight,
        colors: colors
    };
    var onClickEditTooltip = function (id) {
        setEditTooltipId(id.replace("tooltip-", ""));
    };
    var onUpdateTooltip = function (content) {
        var newTooltips = (0, lodash_1.cloneDeep)(tooltips);
        if ((0, primeobjects_helper_util_1.isNonEmptyString)(content)) {
            if (editTooltipId)
                newTooltips[editTooltipId] = content;
        }
        else {
            if (editTooltipId)
                delete newTooltips[editTooltipId];
        }
        setTooltips(newTooltips);
        props.onUpdateTooltips && props.onUpdateTooltips(newTooltips);
    };
    var onAddTag = function (tag) {
        if ((0, primeobjects_helper_util_1.isNonEmptyString)(tag) && props.onAddTag) {
            props.onAddTag(tag);
        }
    };
    return (react_1.default.createElement(react_2.BubbleMenu, { editor: props.editor, className: "menu-wrapper editor-toolbar drop-shadow-lg" },
        react_1.default.createElement("div", { className: "w-full flex flex-col" },
            react_1.default.createElement(HtmlEditorFloatEditToolbarContent, __assign({}, propsHtmlEditorFloatEditToolbarContent, { supportTooltips: supportTooltips, onClickEditTooltip: onClickEditTooltip, onAddTag: onAddTag })),
            supportHighlight == true && react_1.default.createElement("div", { className: "border-t" }),
            supportHighlight == true && (react_1.default.createElement("div", { className: "py-1" },
                react_1.default.createElement(HtmlEditorFloatHighlightToolbarContent, __assign({}, propsHtmlEditorFloatHighlightToolbarContent))))),
        react_1.default.createElement(html_editor_edit_tooltip_1.default, { tooltipEditorProps: props.tooltipEditorProps, content: editTooltipId && tooltips[editTooltipId]
                ? editTooltipId && tooltips[editTooltipId]
                : "", show: !(0, lodash_1.isNil)(editTooltipId), onClose: function () {
                setEditTooltipId(undefined);
            }, onUpdate: onUpdateTooltip })));
};
exports.HtmlEditorFloatEditToolbar = HtmlEditorFloatEditToolbar;
exports.default = exports.HtmlEditorFloatEditToolbar;
//# sourceMappingURL=html-float-edit-toolbar.js.map