"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HtmlEditorFloatInsertToolbar = void 0;
var react_1 = __importDefault(require("react"));
var primeobjects_ui_web_basic_1 = require("primeobjects-ui-web-basic");
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var react_2 = require("@tiptap/react");
// import FloatingMenu from "./extension-floating-menu";
var lodash_1 = require("lodash");
var uploader_1 = require("primeobjects-ui-web-application/build/cjs/controls/uploader");
var primary_color_1 = require("primeobjects-helper-ui/build/cjs/hooks/primary-color");
var FLOAT_MENU_CLASSNAMES = "html-editor-insert-toolbar-button p-1 border border-gray-900 flex content-center items-center bg-white mr-2 text-gray-900 font-semibold";
var HtmlEditorFloatInsertToolbar = function (props) {
    var editor = props.editor, attributeName = props.attributeName, recordId = props.recordId, entityName = props.entityName;
    var primaryColor = (0, primary_color_1.usePrimaryColor)();
    var onUploadPhoto = function (photoInfo) {
        var src = photoInfo.cfSignedResult.signedUrl;
        var rawSrc = photoInfo.cfSignedRawResult.signedUrl;
        editor.commands.setImage({ src: src });
        (0, lodash_1.each)(document.getElementsByTagName("img"), function (img) {
            if (img.src == src) {
                img.onerror = function () {
                    this.rawSrc = rawSrc;
                    this.src = rawSrc;
                };
            }
        });
    };
    return (react_1.default.createElement(react_2.FloatingMenu, { editor: editor, className: props.wrapperClassName },
        react_1.default.createElement("button", { className: FLOAT_MENU_CLASSNAMES, style: editor.isActive("heading", { level: 2 }) ? { color: primaryColor["500"] } : {}, onClick: function () { return editor.chain().focus().toggleHeading({ level: 2 }).run(); } }, "H2"),
        react_1.default.createElement("button", { className: FLOAT_MENU_CLASSNAMES, style: editor.isActive("heading", { level: 3 }) ? { color: primaryColor["500"] } : {}, onClick: function () { return editor.chain().focus().toggleHeading({ level: 3 }).run(); } }, "H3"),
        react_1.default.createElement("button", { className: FLOAT_MENU_CLASSNAMES, onClick: function () { return editor.chain().focus().toggleBulletList().run(); } },
            react_1.default.createElement(primeobjects_ui_web_basic_1.SVG, { src: "/icons/platform/html-editor/material-bullet-list.svg", size: 20 })),
        react_1.default.createElement("button", { className: FLOAT_MENU_CLASSNAMES, onClick: function () { return editor.chain().focus().toggleOrderedList().run(); } },
            react_1.default.createElement(primeobjects_ui_web_basic_1.SVG, { src: "/icons/platform/html-editor/material-numbered-list.svg", size: 20 })),
        react_1.default.createElement("button", { className: FLOAT_MENU_CLASSNAMES },
            react_1.default.createElement(uploader_1.Uploader, { iconStyle: { width: 20, height: 20 }, hideLabel: true, entityName: entityName, attributeName: attributeName, fileType: "Photo", onSuccess: onUploadPhoto, recordId: recordId, fileNamePrefix: (0, primeobjects_helper_util_1.newGuid)(), signedUrlFormat: "webp", uiFormat: "icon", iconUrl: "/icons/platform/image.svg", wrapperStyle: { width: 20, height: 20, border: "none" } }))));
};
exports.HtmlEditorFloatInsertToolbar = HtmlEditorFloatInsertToolbar;
exports.default = exports.HtmlEditorFloatInsertToolbar;
//# sourceMappingURL=html-float-insert-toolbar.js.map