//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { useEffect, useState } from "react";
import { isNonEmptyString } from "primeobjects-helper-util";
import { BubbleMenu } from "@tiptap/react";
import { getGlobalComponent } from "primeobjects-ui-web-application/build/cjs/util";
import HtmlEditorFloatHighlightToolbarContentInternal from "./html-float-highlight-toolbar-content";
import HtmlEditorFloatEditToolbarContentInternal from "./html-float-edit-toolbar-content";
import HtmlEditorEditTooltip from "./html-editor-edit-tooltip";
import { isNil, cloneDeep } from "lodash";
var HtmlEditorFloatEditToolbarContent = undefined;
var HtmlEditorFloatHighlightToolbarContent = undefined;
export var HtmlEditorFloatEditToolbar = function (props) {
    if (!HtmlEditorFloatEditToolbarContent) {
        console.log("Get global components in /html-float-edit-toolbar.tsx");
        HtmlEditorFloatEditToolbarContent = getGlobalComponent("HtmlEditorFloatEditToolbarContent", HtmlEditorFloatEditToolbarContentInternal);
        HtmlEditorFloatHighlightToolbarContent = getGlobalComponent("HtmlEditorFloatHighlightToolbarContent", HtmlEditorFloatHighlightToolbarContentInternal);
    }
    var editor = props.editor, hideH1 = props.hideH1, hideH2 = props.hideH2, hideH3 = props.hideH3, hideH4 = props.hideH4, supportSourceCode = props.supportSourceCode, customButtons = props.customButtons, onHighlight = props.onHighlight, colors = props.colors, supportHighlight = props.supportHighlight, supportTooltips = props.supportTooltips;
    var _a = useState(undefined), editTooltipId = _a[0], setEditTooltipId = _a[1];
    var _b = useState({}), tooltips = _b[0], setTooltips = _b[1];
    useEffect(function () {
        setTooltips(props.tooltips ? props.tooltips : {});
    }, [props.tooltips]);
    var propsHtmlEditorFloatEditToolbarContent = {
        editor: editor,
        hideH1: hideH1,
        hideH2: hideH2,
        hideH3: hideH3,
        hideH4: hideH4,
        supportSourceCode: supportSourceCode
    };
    var propsHtmlEditorFloatHighlightToolbarContent = {
        editor: editor,
        customButtons: customButtons,
        onHighlight: onHighlight,
        colors: colors
    };
    var onClickEditTooltip = function (id) {
        setEditTooltipId(id.replace("tooltip-", ""));
    };
    var onUpdateTooltip = function (content) {
        var newTooltips = cloneDeep(tooltips);
        if (isNonEmptyString(content)) {
            if (editTooltipId)
                newTooltips[editTooltipId] = content;
        }
        else {
            if (editTooltipId)
                delete newTooltips[editTooltipId];
        }
        setTooltips(newTooltips);
        props.onUpdateTooltips && props.onUpdateTooltips(newTooltips);
    };
    var onAddTag = function (tag) {
        if (isNonEmptyString(tag) && props.onAddTag) {
            props.onAddTag(tag);
        }
    };
    return (React.createElement(BubbleMenu, { editor: props.editor, className: "menu-wrapper editor-toolbar drop-shadow-lg" },
        React.createElement("div", { className: "w-full flex flex-col" },
            React.createElement(HtmlEditorFloatEditToolbarContent, __assign({}, propsHtmlEditorFloatEditToolbarContent, { supportTooltips: supportTooltips, onClickEditTooltip: onClickEditTooltip, onAddTag: onAddTag })),
            supportHighlight == true && React.createElement("div", { className: "border-t" }),
            supportHighlight == true && (React.createElement("div", { className: "py-1" },
                React.createElement(HtmlEditorFloatHighlightToolbarContent, __assign({}, propsHtmlEditorFloatHighlightToolbarContent))))),
        React.createElement(HtmlEditorEditTooltip, { tooltipEditorProps: props.tooltipEditorProps, content: editTooltipId && tooltips[editTooltipId]
                ? editTooltipId && tooltips[editTooltipId]
                : "", show: !isNil(editTooltipId), onClose: function () {
                setEditTooltipId(undefined);
            }, onUpdate: onUpdateTooltip })));
};
export default HtmlEditorFloatEditToolbar;
//# sourceMappingURL=html-float-edit-toolbar.js.map